#include <cstring>
#include <iostream>
using namespace std;
int finalni=0;
string rotiraj(string s,int l,int r)
{
    for(int i=0;i<s.length();i++)
       {
        if(i>=l-1 && i<=r-1)
            if(s[i]=='0')
                s[i]='1';
            else
                s[i]='0';
       }
    return s;
}
int brnula(string s)
{
    int nul=0;
     for(int i=0;i<s.length();i++)
        if(s[i]=='0')
                nul++;
        return nul;
}
int brjedinica(string s)
{
    int jed=0;
     for(int i=0;i<s.length();i++)
        if(s[i]!='0')
                jed++;
        return jed;
}
string promenjen(string s,int c)
{
    int brn=brnula(s)+1;
    int pocetni=-1;
    int brj=brjedinica(s);
    string trenutni[s.length()]; int brojac=0;
    for(int i=0;i<s.length();i++)
    {
        if(s[i]=='0')
        {
            brn--;
            if(brn+(c-1)>brj && brojac>0 &&pocetni>=0)
            { cout<<brn<<"\n";
             cout<<brj<<"\n";
                if(brojac-pocetni-1>0)
                {
                     finalni=finalni+c;
                }
                else
                {
                    finalni++;
                }
                 return rotiraj(s,pocetni+1,brojac);
            }
            else
            {
               trenutni[brojac]=s[i];brojac++;
            }
        }
        else
        {   if(pocetni==-1)
            {
                pocetni=i;
            }
            brj--;
            trenutni[brojac]=s[i];brojac++;
        }
    }
    if(brojac>0)
    {
         if(brojac-pocetni-1>0)
                {
                    finalni=finalni+c;
                }
                else
                {
                    finalni++;
                }
                 return rotiraj(s,pocetni+1,brojac);
    }
}
int provera(string s)
{
    for(int i=0;i<s.length();i++)
    {
        if(s[i]!='0')
            return 1;
    }
    return 0;
}
int main()
{
    string s;
    string novi;
    int n,c,q;
    cin>>n>>c>>q;
    cin>>s;

    while(q-->0)
    {
        int l,r;
        cin>>l>>r;
        s=rotiraj(s,l,r);
        novi=s;
        while(provera(novi)==1)
        {
            novi=promenjen(novi,c);
            cout<<novi<<"\n";
        }
        cout<<finalni<<"\n";
        finalni=0;
    }
    return 0;
}